//
// SASF𗧂グāAA[JCoR}hs
//
// $type       : LZH,UNZIP,ZIP,TAR,ARJ,CAB,RAR,BGA,GCA,7Z)
// $cmdline    : eA[JCoR}hɓnR}hC
// $rspfile    : X|Xt@C(gȂ΋󕶎łOK)
// $curdir     : s̃JgfBNg
// #showresult : OŎsʕ\uȂvAȊOŕ\uv
//
// OAYAUTIL.SRCCN[hĂ
//
#SUB AsyncArcCmd($type,$cmdline,$rspfile,$curdir,#showresult)
{
  var $optfile,$data,$r;

  // Õp[^`FbN
  IF (NOT MatchText($type,'(LZH|UNZIP|ZIP|TAR|ARJ|CAB|RAR|BGA|GCA|7Z)')) THEN {
    ShowMessage('p[^G[','AsyncCmd',0);
    Return(0);
  };
  IF ($cmdline=='') THEN {
    ShowMessage('p[^G[','AsyncCmd',0);
    Return(0);
  };
  IF (($rspfile<>'') AND (NOT IsFile($rspfile))) THEN {
    ShowMessage('p[^G[','AsyncCmd',0);
    Return(0);
  };
  IF (NOT IsDir($curdir)) THEN {
    ShowMessage('p[^G[','AsyncCmd',0);
    Return(0);
  };

  // IvVt@C쐬
  MakeTempFilename($optfile);
  IF (#_RESULT!=0) THEN { 
    ShowMessage('IvVt@C쐬s','AsyncCmd',0);
    Return(0);
  };
  IntToStr($r,#showresult);
  $data=$type+$_CR+$_LF+
        $cmdline+$_CR+$_LF+
        $rspfile+$_CR+$_LF+
        $_CUR_DIRECTORY+$_CR+$_LF+
        $r;
  WriteTextFile($optfile,$data,0);
  IF (#_RESULT<>0) THEN {
    Delete($optfile);
    ShowMessage('IvVt@C쐬s','AsyncCmd',0);
    Return(0);
  };

  // s!!
  Exec('SASF /KEY=AsyncArc.KEY /CMD=P /OPT='+$optfile,'',1,0);
  return(1);
}

//
// SASF𗧂グLZH쐬
//
#SUB AsyncMakeLZHSub(#mode,#showresult)
{
  var $lzhname,$rspfile,$cmdline,$title;

  $title='LZHt@C̍쐬(񓯊)';
  $lzhname='';
  InputPackFName($lzhname,$title,'UNTITLED.LZH','.LZH');
  MakePackRspfile($rspfile,$title,'');
  CASE #mode OF {
    1: { $cmdline='a '+$lzhname+' @'+$rspfile+' -x1r2 -a1 -o2 -jst0'; },
    ELSE: { $cmdline='a '+$lzhname+' @'+$rspfile+' -x1r2 -a1 -o0 -jst0'; }
  };
  AsyncArcCmd('LZH',$cmdline,$rspfile,$_CUR_DIRECTORY,#showresult);
  IF (#_RESULT<>1) THEN { Delete($rspfile); };
}

//
// SASF𗧂グZIP쐬
//
#SUB AsyncMakeZIPSub(#mode,#showresult)
{
  var $title,$opt,$zipname,$rspfile,$cmdline;

  $title='ZIPt@C̍쐬(񓯊)'; $opt='';
  IF (#mode==1) THEN {
    $title='ÍZIPt@C̍쐬(񓯊)'; $opt='-e ';
  };
  $zipname=''; $rspfile='';
  InputPackFName($zipname,$title,'UNTITLED.ZIP','.ZIP');
  MakePackRspfile($rspfile,$title,'ZIP');
  $cmdline='-r -S -9 '+$opt+$zipname+' @'+$rspfile;
  AsyncArcCmd('ZIP',$cmdline,$rspfile,$_CUR_DIRECTORY,#showresult);
  IF (#_RESULT<>1) THEN { Delete($rspfile); };
}

//
// SASF𗧂グăA[JCut@C
//
#SUB AsyncUnpack(#showresult)
{
  var #max,#i,$defdir,$trgdir,$optfile,$data,$r,$arcfiles;

  // t@C[[h`FbN
  CheckFilerMode();
  // t@C̃`FbN!!
  CheckFileNum();
  GetMaxMarkIdx(#max);
  IF (#max==-1) THEN { return(0); };

  // A[JCuXg쐬
  $arcfiles='';
  FOR #i=0 TO #max DO {
    GetMarkFILENAME(#_ACTIVEWINDOW,$data,#i);
    IF ($arcfiles=='') THEN {
      $arcfiles=$data;
    } ELSE {
      $arcfiles=$arcfiles+$_CR+$_LF+$data;
    };
  };

  // 𓀐擾!!
  GetDefDir($defdir);
  InputDir($trgdir,'𓀐͂Ă',$defdir,2); 
  IF (#_RESULT==0) THEN { return(0); };

  // IvVt@C쐬
  MakeTempFilename($optfile);
  IF (#_RESULT!=0) THEN { 
    ShowMessage('IvVt@C쐬s','AsyncUnpack',0);
    Return(0);
  };
  IntToStr($r,#showresult);
  $data=$trgdir+$_CR+$_LF+
        $_CUR_DIRECTORY+$_CR+$_LF+
        $r+$_CR+$_LF+
        $arcfiles;
  WriteTextFile($optfile,$data,0);
  IF (#_RESULT<>0) THEN {
    Delete($optfile);
    ShowMessage('IvVt@C쐬s','AsyncUnpack',0);
    Return(0);
  };

  // s!!
  Exec('SASF /KEY=AsyncArc.KEY /CMD=U /OPT='+$optfile,'',1,0);
  return(1);

}
